#
# Startup Tcl/Tk script for sound development
#
# Highly custom for my setup, but easy to adapt.
#
# Preferably start the soundtest executable as root
#
# that would give the lowest latency
# then use: export PA_MIN_LATENCY_MSEC=10
# when starting as normal user, (automatic) more 
# than 100 MSec is more likely to be needed.

# Remember the background sound process ID

set soundtestpid [exec soundtest &]
# attempt to auto-test, start if not running
puts ""
# if [catch {exec ps -aef | grep soundtest }] {
#    set soundtestpid [exec soundtest &]
#    puts "started soundtest, PID=$soundtestpid"
# } { puts "soundtest server is already running"
#    set soundtestpid {}
# }

# read bwise and pcom
#source ~theo/Tcl/bwise343start_redhat.tcl
#source ~theo/Tcl/pcomlbf.tcl
source bwise0341pre_console.tcl
# cd c:/cygwin/home/Theo/Soundtest
source pcomlbf.tcl
# cd c:/cygwin/home/Theo/Soundtest
#proc pcsend a {send $a}

# change the console a bit
console eval {.console conf -font {courier 14} -bg white}
#update

# Windows layout for my screen
console eval {wm geom . 80x24+193+335}

wm geom .pc 335x290+0+410
destroy .pc.fl
destroy .pc.f
update

# pcom must be set up and automatically connects to sound prog
# assuming a 1/3 second is enough to start the soundtest socket
set remip localhost
set myport 8200
after 500 
.pc.fc3.connect invoke

# make the pcom entry field not clear after Return is pressed
bind .pc.ecom <Key-Return> {
    pcsend $intext;
    .pc.tcom insert end "LOCAL: $intext\n";
    .pc.tcom see end
}

# create harmonics sliders
sliders {{h1 100} {h2 100} {h3 100} {h4 100} {h5 100} {h6 100} {h7 100} {h8 100}} .sl2
# and put in place
wm geom .sl2 400x227+217+0

# some additional/changed procedures
source procmakeadd1.tcl
source procsst1.tcl

# make the Quit button in Bwise stop the sound program, too
.fb.quit conf -command { pcsend "exit"; after 100;
   if {$soundtestpid != {}} { catch {exec kill -9 $soundtestpid} ;
                              puts "killed $soundtestpid " }
   exit
}

# Set up the sound which is played at startup
# frequency in milliherz and amplitude from 0 to 1000
# set all volumes to 10 %
for {set i 0} {$i < 256} {incr i} {
   pcsend "genvol $i 100"
}
pcsend "genfreq 0 220000"


